% *******************************************
% *                                         *
% * Thomas Hzard                           *
% *                                         *
% * TD AMEA - Mthodes de synthse sonore 1 *
% *                                         *
% *******************************************


% Script de synthse additive
% Les paramtres que l'utilisteur peut changer se trouvent dans la partie 1


clear variables;
close all;


% 1. Paramtres utilisateurs
% **************************

% Dure du signal (scalaire, en secondes)
d = 1;
% Frquence d'chantillonnage (scalaire, en Hertz)
Fs = 44100;
% Nombre d'harmoniques (scalaire)
N = 5;
% Frquence fondamentale (scalaire, en Hertz)
f_0 = 200;
% Vecteur des phases (vecteur de taille Nx1)
phi_v = zeros(N,1);
% Vecteur des amplitudes (vecteur de taille Nx1)
a_v = 1./(1:N)';
a_v(2:2:N) = 0;


% 2. Calculs prliminaires
% ************************

% Nombre d'chantillons
Nech = d*Fs;
% Vecteurs des frquences
freq_v = (1:N)'*f_0;


% 3. Synthse
% ***********

% Construction des harmoniques
t_v = (1:Nech)'/Fs;
s_m = zeros(Nech,N);
for ii = 1:N
    s_m(:,ii) = a_v(ii)*sin(2*pi*freq_v(ii)*t_v+phi_v(ii));
end
% Addition
x_v = sum(s_m,2);


% 4. Rsultats
% ************

% Ecoute du signal (fenetr)
Lfen = round(Fs/10);
Ldemfen = ceil(Lfen/2);
fen = hanning(Lfen)';
fens = [fen(1:Ldemfen) ones(1,Nech-Lfen) fen(Ldemfen+1:end)]';
son = x_v.*fens;
son = son /(max(son)+0.1);
soundsc(son,Fs);

% Calcul du spectre
x_fft_v0 = fft(x_v);
Nfft = length(x_fft_v0);
x_fft_v1 = x_fft_v0(1:Nfft/2);
f_fft_v = (0:(Nfft/2)-1)/Nfft*Fs;

% Affichage des rsultats
Nper = 2; %Nombre de priodes  afficher
CoeffTaille = 2; % Coeff de taile de la fenetre
fmax = Fs/2; % frquence max sur l'affichage du spectre
f1 = figure('Units', 'centimeters', 'OuterPosition', [2,2,CoeffTaille*8+2.5,CoeffTaille*5+4.1]);
p1 = subplot(2,1,1);
plot(t_v(1:floor(Nper*Fs/f_0)),x_v(1:floor(Nper*Fs/f_0)));
xlabel('temps (s)');
ylabel('amplitude');
p2 = subplot(2,1,2);
plot(f_fft_v,abs(x_fft_v1));
xlim([0,fmax]);
xlabel('frquence (Hz)');
ylabel('amplitude');
